; pcxLib.ASM                                                                 ;
; Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.   ;

;****************************************************************************;
;                                                                            ;
; Function declarations for the PCX Programmer's Toolkit, for Assembly       ;
; Language.                                                                  ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
; Microsoft ASM 5.x version.              Programmer: Chris Howard  2/01/89  ;
;                                                                            ;
;****************************************************************************;

;PCX Version number
pcxhard      equ    5                       ;PCX version, 5 = 3.0 w/palette

;PCX Display modes                        
pcxTEXT      equ    0                       ;Text mode
pcxGRAPH     equ    1                       ;Graphics mode

;PCX Display types -- MUST start at 0 for calc offsets
pcxMINDISP   equ    0                       ;Minimum display type
pcxCGA_4     equ    0                       ;CGA Mode  4H  (320x200x4)
pcxCGA_6     equ    1                       ;CGA Mode  5H  (640x200x2)
pcxEGA_D     equ    2                       ;EGA Mode  DH  (320x200x16)
pcxEGA_E     equ    3                       ;EGA Mode  EH  (640x200x16)
pcxEGA_F     equ    4                       ;EGA Mode  FH  (640x350x2)
pcxEGA_10    equ    5                       ;EGA Mode 10H  (640x350x16)
pcxVGA_11    equ    6                       ;VGA Mode 11H  (640x480x2)
pcxVGA_12    equ    7                       ;VGA Mode 12H  (640x480x16)
pcxVGA_13    equ    8                       ;VGA Mode 13H  (320x200x256)
pcxHERC      equ    9                       ;Hercules      (720x348x2)

;PCX Extended Display Types (new to version 3.50)
pcxXGA_29    equ    10                      ;Tseng    29H  (800x600x16)
pcxXGA_2D    equ    11                      ;Tseng    2DH  (640x350x256)
pcxXGA_2E    equ    12                      ;Tseng    2EH  (640x480x256)
pcxXGA_30    equ    13                      ;Tseng    30H  (800x600x256)
pcxXGA_58    equ    14                      ;Paradise 58H  (800x600x16)
pcxXGA_59    equ    15                      ;Paradise 59H  (800x600x2)
pcxXGA_5E    equ    16                      ;Paradise 5EH  (640x400x256)
pcxXGA_5F    equ    17                      ;Paradise 5FH  (640x480x256)
pcxXGA_62    equ    18                      ;Video 7  62H  (800x600x16)
pcxXGA_66    equ    19                      ;Video 7  66H  (640x400x256)
pcxXGA_67    equ    20                      ;Video 7  67H  (640x480x256)
pcxXGA_69    equ    21                      ;Video 7  69H  (800x600x256)
pcxMAXDISP   equ    21                      ;Maximum display type

;Printer Ports
pcxLPT1      equ    0                       ;Printer Port 1
pcxLPT2      equ    1                       ;Printer Port 2
pcxLPT3      equ    2                       ;Printer Port 3

;Printer Types
pcxMINPRINT  equ    0                       ;Minimum printer type
pcxLASER     equ    0                       ;HP LaserJet
pcxDOTMAT    equ    1                       ;Dot Matrix
pcxMAXPRINT  equ    1                       ;Maximum printer type

;Printer Modes
pcxDRAFT     equ    0                       ;Draft mode
pcxQUALITY   equ    1                       ;Quality

;Printer Scales
pcxSCALE100  equ    0                       ;100%
pcxSCALE75   equ    1                       ; 75%
pcxSCALE50   equ    2                       ; 50%
pcxSCALE25   equ    3                       ; 25%
pcxSCALE200  equ    4                       ;200%

;Printer flags
pcxNRESET    equ    0                       
pcxRESET     equ    1                       ;Reset before printing
pcxNEJECT    equ    0                       
pcxEJECT     equ    1                       ;Eject after printing

;Searches
pcxFIRST     equ    0                       ;Find first matching entry
pcxNEXT      equ    1                       ;Find next matching entry

;Logical Operations
pcxSET       equ    0                       ;SET pixel value directly
pcxAND       equ    1                       ;AND pixel value with data
pcxOR        equ    2                       ;OR  pixel value with data
pcxXOR       equ    3                       ;XOR pixel value with data

;Virtual Screens
pcxEMM       equ    0                       ;Expanded     virtual buffer
pcxCMM       equ    1                       ;Conventional virtual buffer

;Miscellaneous
pcxTRUE   equ       1                       ;True value
pcxFALSE  equ       0                       ;False value
pcxSYNC   equ       1                       ;Sync byte for image headers

;Video Info constants
viNONE       equ    0                       ;No adapter/display
viMDA        equ    1                       ;Monochrome Display Adapter
viCGA        equ    2                       ;Color Graphics Adapter
viEGA        equ    3                       ;Enhanced Graphics Adapter
viMCGA       equ    4                       ;
viVGA        equ    5                       ;Video Graphics Array
viHGC        equ    80H                     ;Hercules Monochrome
viHGCP       equ    81H                     ;Hercules Plus
viHGCC       equ    82H                     ;Hercules InColor

viMDAdisp    equ    1                       ;Monochrome Display
viCGAdisp    equ    2                       ;CGA Display
viEGAdisp    equ    3                       ;EGA Display
viVGAmono    equ    4                       ;VGA Monochrome Display
viVGAcol     equ    5                       ;VGA Color Display

;VGA Chip sets
chipUNKNOWN  equ    0                       ;Unknown chip set
chipTSENG    equ    1                       ;Tseng Labs chip set
chipPARA     equ    2                       ;Paradise
chipV7       equ    3                       ;Video 7

;Hercules Configuration
HERCdiag     equ    0                       ;Hercules diagnostic mode
HERChalf     equ    1                       ;         half mode
HERCfull     equ    3                       ;         full mode

;Error Codes
pcxSUCCESS          equ  0                  ;Successful
pcxERR_OPEN         equ  -1                 ;Error opening file
pcxERR_BUFSMALL     equ  -2                 ;Buffer is too small
pcxERR_READ         equ  -3                 ;Error in reading from file
pcxERR_WRITE        equ  -4                 ;Error in writing to file
pcxERR_NOTPCX       equ  -5                 ;Not a valid pcx buffer/file
pcxERR_BADDISP      equ  -6                 ;Display not defined or invalid
pcxERR_BADMODE      equ  -7                 ;Bad display mode
pcxERR_BADPAGE      equ  -8                 ;Bad page
pcxERR_BADPAL       equ  -9                 ;Bad palette
pcxERR_NOPAL        equ  -10                ;No palette available
pcxERR_NOPALGRAB    equ  -11                ;Palette is not grabbed
pcxERR_NOTPCXLIB    equ  -12                ;Not a PCX library
pcxERR_NOSYNC       equ  -13                ;Lost image synch in library
pcxERR_NOTINLIB     equ  -14                ;Image not found in library
pcxERR_CLIPPARM     equ  -15

pcxERR_NOTIMPL      equ  -900               ;Not implemented yet
pcxERR_GENERAL      equ  -999               ;General error

;New errors for version 3.5
pcxERR_BADPRINT     equ  -16                ;Bad printer type
pcxERR_BADPORT      equ  -17                ;Bad printer port
pcxERR_PRINTER      equ  -18                ;Printer error (timeout,i/o,paper)
pcxERR_NOTBW        equ  -19                ;Not a Black/White image 
pcxERR_ESCAPE       equ  -20                ;Escape key was pressed  
pcxERR_NOEMM        equ  -21                ;No EMM driver was found
pcxERR_EMMFAIL      equ  -22                ;General EMM driver failure
pcxERR_EMMNOMEM     equ  -23                ;No EMM memory available   
pcxERR_BADMEMTYPE   equ  -24                ;Bad virtual memory type   
pcxERR_CMMFAIL      equ  -25                ;General CMM alloc/free error
pcxERR_CMMNOMEM     equ  -26                ;No CMM memory available      

;PCX supported display structure
dispstruc STRUC
dtype     db        ?                       ;Display type (from above list)
dmodestr  db        '                    '  ;Place for ASCII display string
dmodestrt db        0                       ;String terminator
dmode     db        ?                       ;Mode for this resolution
dbitpx    db        ?                       ;Bits per pixel
dhres     dw        ?                       ;Horiz and Vert resolution of disp
dvres     dw        ?
dplanes   db        ?                       ;Number of planes in this mode
dpages    db        ?                       ;Number of pages in this mode
dbegseg   dw        ?                       ;Beginning segment address
dpagesize dw        ?                       ;Page size for this mode
dpal      dw        ?                       ;Palette type
ddisplay  dd        ?                       ;Display Function (FAR PTR)
dbuffer   dd        ?                       ;Buffer  Function (FAR PTR)
dvirtual  dd        ?                       ;Virtual Function (FAR PTR)
dput      dd        ?                       ;Put     Function (FAR PTR)
dget      dd        ?                       ;Get     Function (FAR PTR)
dispstruc ENDS

;PCX header
headstruc STRUC
manuf     db        ?                       ;Always =10 for Paintbrush files
hard      db        ?                       ;Version information
encod     db        ?                       ;Run-length encoding mode (=1)
bitpx     db        ?                       ;Bits per pixel
x1        dw        ?                       ;Picture dimensions (inclusive)
y1        dw        ?
x2        dw        ?
y2        dw        ?
hres      dw        ?                       ;Display horiz and vert resolution
vres      dw        ?
clrma     db        48 dup(?)               ;Pallete
vmode     db        ?                       ;(ignored)
nplanes   db        ?                       ;Number of planes (=0 if ver 2.5)
bplin     dw        ?                       ;Bytes per line
palinfo   dw        ?                       ;Palette Info (1=color, 2=gray)
shres     dw        ?                       ;Scanner resolution
svres     dw        ?
xtra      db        54 dup(?)               ;Extra space (filler)
headstruc ENDS

headlen   equ       128                     ;Header size (length)

;Library header
libstruc  STRUC
lid       db        10 dup(?)               ;Library ID string
lcopy     db        50 dup(?)               ;Copyright notice
lversion  dw        ?                       ;pcxLib version
lvol      db        40 dup(?)               ;Library volume label
lxtra     db        20 dup(?)               ;filler
libstruc  ENDS

liblen    equ       122

;Library image header
limstruc  STRUC
isync     db        ?                       ;Synch byte
iname     db        13 dup(?)               ;Image name (keep byte align)
isize_l   dw        ?                       ;Image size (low  word)
isize_h   dw        ?                       ;Image size (high word)
idate     dw        ?                       ;Image date
itime     dw        ?                       ;Image time
ipack     dw        ?                       ;Packing type
inote     db        40 dup(?)               ;Image comments
ixtra     db        20 dup(?)               ;filler
limstruc  ENDS

limlen    equ       84

;Video Info structure
vistruc   STRUC
adapter1  db        ?                       ;First adapter type
display1  db        ?                       ; and display attached
adapter2  db        ?                       ;Second adapter type
display2  db        ?                       ; and display attached
vistruc   ENDS

;Function declarations (Comment out so that all functions are not linked in)
;         EXTRN     pcxFileBuffer           : FAR
;         EXTRN     pcxBufferFile           : FAR
;         EXTRN     pcxSetDisplay           : FAR
;         EXTRN     pcxGetDisplay           : FAR
;         EXTRN     pcxSetMode              : FAR
;         EXTRN     pcxSetBuffer            : FAR
;         EXTRN     pcxBufferDisplay        : FAR
;         EXTRN     pcxDisplayBuffer        : FAR
;         EXTRN     pcxLibBuffer            : FAR
;         EXTRN     pcxFileDisplay          : FAR
;         EXTRN     pcxDisplayFile          : FAR
;         EXTRN     pcxLibDisplay           : FAR
;         EXTRN     pcxSetPage              : FAR
;         EXTRN     pcxGetPage              : FAR
;         EXTRN     pcxVerifyBuffer         : FAR
;         EXTRN     pcxGetBufferHeader      : FAR
;         EXTRN     pcxSetBufferHeader      : FAR
;         EXTRN     pcxGetBufferType        : FAR
;         EXTRN     pcxVerifyFile           : FAR
;         EXTRN     pcxGetFileHeader        : FAR
;         EXTRN     pcxSetFileHeader        : FAR
;         EXTRN     pcxGetFileType          : FAR
;         EXTRN     pcxGetLibHeader         : FAR
;         EXTRN     pcxGetLibType           : FAR
;         EXTRN     pcxDecodePalette        : FAR
;         EXTRN     pcxEncodePalette        : FAR
;         EXTRN     pcxSetDisplayPalette    : FAR
;         EXTRN     pcxGetDisplayPalette    : FAR
;         EXTRN     pcxSetBufferPalette     : FAR
;         EXTRN     pcxGetBufferPalette     : FAR
;         EXTRN     pcxSetFilePalette       : FAR
;         EXTRN     pcxGetFilePalette       : FAR
;         EXTRN     pcxGetLibPalette        : FAR
;         EXTRN     pcxBeginPaletteGrab     : FAR
;         EXTRN     pcxEndPaletteGrab       : FAR
                                            
;New 3.5 Functions
;         EXTRN     pcxGetVersion           : FAR
;         EXTRN     pcxTextBuffer           : FAR
;         EXTRN     pcxBufferText           : FAR
;         EXTRN     pcxVideoInfo            : FAR
;         EXTRN     pcxQueryChipset         : FAR
;         EXTRN     pcxGetDisplayInfo       : FAR
;         EXTRN     pcxSetPrinter           : FAR
;         EXTRN     pcxBufferPrint          : FAR
;         EXTRN     pcxFilePrint            : FAR
;         EXTRN     pcxLibPrint             : FAR
;         EXTRN     pcxEMInstalled          : FAR
;         EXTRN     pcxVirtualSize          : FAR
;         EXTRN     pcxVirtualFree          : FAR
;         EXTRN     pcxCreateVirtual        : FAR
;         EXTRN     pcxDestroyVirtual       : FAR
;         EXTRN     pcxBufferVirtual        : FAR
;         EXTRN     pcxFileVirtual          : FAR
;         EXTRN     pcxLibVirtual           : FAR
;         EXTRN     pcxSetHerc              : FAR
;         EXTRN     pcxModeCheck            : FAR
;         EXTRN     pcxVirtualDisplay       : FAR
;         EXTRN     pcxVirtualScroll        : FAR
;         EXTRN     pcxLibSearch            : FAR
;         EXTRN     pcxVirtualPrint         : FAR
;         EXTRN     pcxDisplayPrint         : FAR
;         EXTRN     pcxPutImage             : FAR
;         EXTRN     pcxGetImage             : FAR
