* Structs.PRG                                                               *
* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.  *

*****************************************************************************
*                                                                           *
* This program demonstrates the usage of various toolkit structures. It is  *
* an example Clipper routine for the PCX Programmer's Toolkit.              *
*                                                                           *
* Nantucket Clipper                       Programmer: Chris Howard  4/15/89 *
*                                                                           *
*****************************************************************************


* Include the PCX Toolkit defines
SET PROCEDURE TO pcxlib
DO  pcxInit

* Globals
pcximage = "pcxTest.PCX"
pcxtype  = pcxCGA_4

DECLARE viadapt[6]
        viadapt[1] = "[None]"
        viadapt[2] = "MDA"
        viadapt[3] = "CGA"
        viadapt[4] = "EGA"
        viadapt[5] = "MCGA"
        viadapt[6] = "VGA"

DECLARE viherc[3]
        viherc[1]  = "HGC"
        viherc[2]  = "HGC+"
        viherc[3]  = "InColor"

DECLARE vidisp[6]
        vidisp[1]  = "[None]"
        vidisp[2]  = "MDA Monochrome Display"
        vidisp[3]  = "CGA Color Display"
        vidisp[4]  = "EGA Color Display"
        vidisp[5]  = "VGA Monochrome Display"
        vidisp[6]  = "VGA Color Display"

DECLARE chip[4]
        chip[1]    = "[Unknown]"
        chip[2]    = "Tseng Labs"
        chip[3]    = "Paradise"
        chip[4]    = "Video7"

header  = SPACE(128)
vi      = SPACE(4)
di      = SPACE(60)

**********

* Main

  * Display program header
  ?
  ? "͸"
  ? " Structs: Example Structs Clipper Program   PCX Programmer's Toolkit 3.50 "
  ? " Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. "
  ? ";"
  ?

  * Get a key, to begin
  ? "Press a key to run . . ."
  INKEY(0)

  * Look at the current hardware, to find a B/W mode
  retcode = pcxVI(vi)

  * Display what we found
  ?
  ? "Video Information:"
  ?
  FOR i = 1 to 3 STEP 2
    * Get the adapter and display
    adapter = ASC(SUBSTR(vi,i,1))
    display = ASC(SUBSTR(vi,i+1,1))
    * Is there an adapter here?
    IF (adapter <> viNONE) 
      * Display, and use the other array if Hercules
      IF (adapter >= viHGC)
        ? "  ",viherc[adapter-viHGC+1]," with a ",vidisp[display+1]
      ELSE
        ? "  ",viadapt[adapter+1]," with a ",vidisp[display+1]
      ENDIF
      * If this is a VGA, try to find a chipset
      IF (adapter = viVGA) 
        chipset = pcxQC()
        ? "   chipset: ",chip[chipset+1]
      ENDIF
    ENDIF
  NEXT
  ?

  * Wait for a key
  ? "Press a key to continue . . ."
  INKEY(0)

  * Get an image header
  retcode = pcxGFH(pcximage,header)

  * If we read it successfully, display some information
  IF (retcode = pcxSUCCESS)

    ?
    ? "Header structure for ",pcximage,": "
    ?
    ? "   manuf: ",ASC(SUBSTR(header, 1,1))
    ? "    hard: ",ASC(SUBSTR(header, 2,1))
    ? "   encod: ",ASC(SUBSTR(header, 3,1))
    ? "   bitpx: ",ASC(SUBSTR(header, 4,1))
    ? "      x1: ",ASC(SUBSTR(header, 5,1))+ASC(SUBSTR(header, 6,1))*256
    ? "      y1: ",ASC(SUBSTR(header, 7,1))+ASC(SUBSTR(header, 8,1))*256
    ? "      x2: ",ASC(SUBSTR(header, 9,1))+ASC(SUBSTR(header,10,1))*256
    ? "      y2: ",ASC(SUBSTR(header,11,1))+ASC(SUBSTR(header,12,1))*256
    ? "    hres: ",ASC(SUBSTR(header,13,1))+ASC(SUBSTR(header,14,1))*256
    ? "    vres: ",ASC(SUBSTR(header,15,1))+ASC(SUBSTR(header,16,1))*256
    ? "   vmode: ",ASC(SUBSTR(header,65,1))
    ? " nplanes: ",ASC(SUBSTR(header,66,1))
    ? "   bplin: ",ASC(SUBSTR(header,67,1))+ASC(SUBSTR(header,68,1))*256
    ?

  ENDIF

  * Wait for a key
  ? "Press a key to continue . . ."
  INKEY(0)

  * Now get information on a PCX type
  retcode = pcxGDI(pcxEGA_10,di)

  * Display some information
  ?
  ? "Information on the 'pcxEGA_10' display type:"
  ?
  ? "     type: ",ASC(SUBSTR(di,1,1))
  ? "  descrip: [",SUBSTR(di,2,21),"]"
  ? "     mode: ",ASC(SUBSTR(di,23,1))
  ? "    bitpx: ",ASC(SUBSTR(di,24,1))
  ? "     hres: ",ASC(SUBSTR(di,25,1))+ASC(SUBSTR(di,26,1))*256
  ? "     vres: ",ASC(SUBSTR(di,27,1))+ASC(SUBSTR(di,28,1))*256
  ? "   planes: ",ASC(SUBSTR(di,29,1))
  ? "    pages: ",ASC(SUBSTR(di,30,1))
  ? "   begseg: ",ASC(SUBSTR(di,31,1))+ASC(SUBSTR(di,32,1))*256
  ? " pagesize: ",ASC(SUBSTR(di,33,1))+ASC(SUBSTR(di,34,1))*256
  ?

  * Wait for a key
  ? "Press a key to end . . ."
  INKEY(0)


RETURN && Main

