* pcxInt.FOR                                                                *
* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.  *

*****************************************************************************
*                                                                           *
* Function declarations for the PCX Programmer's Toolkit, MS Fortran 4.1.   *
*                                                                           *
*                                                                           *
*                                                                           *
* Microsoft Fortran 4.1                   Programmer: Chris Howard 12/09/88 *
*                                                                           *
*****************************************************************************

$NOTRUNCATE

* Function Declarations
      INTERFACE TO INTEGER*2 FUNCTION pcxFileBuffer
     +[PASCAL,ALIAS: 'PCXFILEBUFFER']
     +(filename [REFERENCE],buffer [REFERENCE],bufmax)
      CHARACTER     filename
      CHARACTER     buffer
      INTEGER*2     bufmax
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxBufferFile
     +[PASCAL,ALIAS: 'PCXBUFFERFILE']
     +(buffer [REFERENCE],bufsize,filename [REFERENCE])
      CHARACTER     buffer
      INTEGER*2     bufsize
      CHARACTER     filename
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetDisplay
     +[PASCAL,ALIAS: 'PCXSETDISPLAY']
     +(disptype)
      INTEGER*2     disptype
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetDisplay
     +[PASCAL,ALIAS: 'PCXGETDISPLAY']
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetMode
     +[PASCAL,ALIAS: 'PCXSETMODE']
     +(dispmode)
      INTEGER*2     dispmode
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetBuffer
     +[PASCAL,ALIAS: 'PCXSETBUFFER']
     +(buffer [REFERENCE],bufmax)
      CHARACTER     buffer
      INTEGER*2     bufmax
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxBufferDisplay
     +[PASCAL,ALIAS: 'PCXBUFFERDISPLAY']
     +(buffer [REFERENCE],bufsize,x,y,page)
      CHARACTER     buffer
      INTEGER*2     bufsize
      INTEGER*2     x,y,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxDisplayBuffer
     +[PASCAL,ALIAS: 'PCXDISPLAYBUFFER']
     +(buffer [REFERENCE],bufmax,x1,y1,x2,y2,page)
      CHARACTER     buffer
      INTEGER*2     bufmax
      INTEGER*2     x1,y1,x2,y2,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxLibBuffer
     +[PASCAL,ALIAS: 'PCXLIBBUFFER']
     +(libname [REFERENCE],filename [REFERENCE],
     + buffer [REFERENCE],bufmax)
      CHARACTER     libname,filename
      CHARACTER     buffer
      INTEGER*2     bufmax
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxFileDisplay
     +[PASCAL,ALIAS: 'PCXFILEDISPLAY']
     +(filename [REFERENCE],x,y,page)
      CHARACTER     filename
      INTEGER*2     x,y,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxDisplayFile
     +[PASCAL,ALIAS: 'PCXDISPLAYFILE']
     +(filename [REFERENCE],x1,y1,x2,y2,page)
      CHARACTER     filename
      INTEGER*2     x1,y1,x2,y2,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxLibDisplay
     +[PASCAL,ALIAS: 'PCXLIBDISPLAY']
     +(filename [REFERENCE],libname [REFERENCE],x,y,page)
      CHARACTER     libname,filename
      INTEGER*2     x,y,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetPage
     +[PASCAL,ALIAS: 'PCXSETPAGE']
     +(page)
      INTEGER*2     page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetPage
     +[PASCAL,ALIAS: 'PCXGETPAGE']
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxVerifyBuffer
     +[PASCAL,ALIAS: 'PCXVERIFYBUFFER']
     +(buffer [REFERENCE])
      CHARACTER     buffer
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetBufferHeader
     +[PASCAL,ALIAS: 'PCXGETBUFFERHEADER']
     +(buffer [REFERENCE],header [REFERENCE])
      INTEGER*2     buffer
      INTEGER*1     header
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetBufferHeader
     +[PASCAL,ALIAS: 'PCXSETBUFFERHEADER']
     +(buffer [REFERENCE],header [REFERENCE])
      CHARACTER     buffer
      INTEGER*1     header
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetBufferType
     +[PASCAL,ALIAS: 'PCXGETBUFFERTYPE']
     +(buffer [REFERENCE])
      CHARACTER     buffer
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxVerifyFile
     +[PASCAL,ALIAS: 'PCXVERIFYFILE']
     +(filename [REFERENCE])
      CHARACTER     filename
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetFileHeader
     +[PASCAL,ALIAS: 'PCXGETFILEHEADER']
     +(filename [REFERENCE],header [REFERENCE])
      CHARACTER     filename
      INTEGER*1     header
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetFileHeader
     +[PASCAL,ALIAS: 'PCXSETFILEHEADER']
     +(filename [REFERENCE],header [REFERENCE])
      CHARACTER     filename
      INTEGER*1     header
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetFileType
     +[PASCAL,ALIAS: 'PCXGETFILETYPE']
     +(filename [REFERENCE])
      CHARACTER     filename
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetLibHeader
     +[PASCAL,ALIAS: 'PCXGETLIBHEADER']
     +(libname [REFERENCE],filename [REFERENCE],header [REFERENCE])
      CHARACTER     libname,filename
      INTEGER*1     header
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetLibType
     +[PASCAL,ALIAS: 'PCXGETLIBTYPE']
     +(libname [REFERENCE],filename [REFERENCE])
      CHARACTER     libname,filename
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxDecodePalette
     +[PASCAL,ALIAS: 'PCXDECODEPALETTE']
     +(disptype,clrma [REFERENCE],pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     clrma,pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxEncodePalette
     +[PASCAL,ALIAS: 'PCXENCODEPALETTE']
     +(disptype,clrma [REFERENCE],pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     clrma,pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetDisplayPalette
     +[PASCAL,ALIAS: 'PCXSETDISPLAYPALETTE']
     +(pal [REFERENCE])
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetDisplayPalette
     +[PASCAL,ALIAS: 'PCXGETDISPLAYPALETTE']
     +(pal [REFERENCE])
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetBufferPalette
     +[PASCAL,ALIAS: 'PCXSETBUFFERPALETTE']
     +(disptype,buffer [REFERENCE],bufsize,pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     buffer
      INTEGER*2     bufsize
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetBufferPalette
     +[PASCAL,ALIAS: 'PCXGETBUFFERPALETTE']
     +(disptype,buffer [REFERENCE],bufsize,pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     buffer
      INTEGER*2     bufsize
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetFilePalette
     +[PASCAL,ALIAS: 'PCXSETFILEPALETTE']
     +(disptype,filename [REFERENCE],pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     filename
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetFilePalette
     +[PASCAL,ALIAS: 'PCXGETFILEPALETTE']
     +(disptype,filename [REFERENCE],pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     filename
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetLibPalette
     +[PASCAL,ALIAS: 'PCXGETLIBPALETTE']
     +(disptype,libname [REFERENCE],filename [REFERENCE],
     + pal [REFERENCE])
      INTEGER*2     disptype
      CHARACTER     libname,filename
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxBeginPaletteGrab
     +[PASCAL,ALIAS: 'PCXBEGINPALETTEGRAB']
     +(pal [REFERENCE])
      CHARACTER     pal
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxEndPaletteGrab
     +[PASCAL,ALIAS: 'PCXENDPALETTEGRAB']
      END

* New 3.5 Functions

      INTERFACE TO INTEGER*2 FUNCTION pcxGetVersion
     +[PASCAL,ALIAS: 'PCXGETVERSION']
     +(verbuf [REFERENCE])
      CHARACTER     verbuf
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxTextBuffer
     +[PASCAL,ALIAS: 'PCXTEXTBUFFER']
     +(textbuf [REFERENCE])
      CHARACTER     textbuf
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxBufferText
     +[PASCAL,ALIAS: 'PCXBUFFERTEXT']
     +(textbuf [REFERENCE])
      CHARACTER     textbuf
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxVideoInfo
     +[PASCAL,ALIAS: 'PCXVIDEOINFO']
     +(vi [REFERENCE])  
      INTEGER*1     vi
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxQueryChipset
     +[PASCAL,ALIAS: 'PCXQUERYCHIPSET']
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetDisplayInfo
     +[PASCAL,ALIAS: 'PCXGETDISPLAYINFO']
     +(disptype,di [REFERENCE])
      INTEGER*2     disptype
      INTEGER*1     di
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetPrinter
     +[PASCAL,ALIAS: 'PCXSETPRINTER']
     +(port,device,mode,scale,reset,eject)
      INTEGER*2     port,device,mode,scale,reset,eject
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxBufferPrint
     +[PASCAL,ALIAS: 'PCXBUFFERPRINT']
     +(buffer [REFERENCE],bufsize,x,y)
      CHARACTER     buffer
      INTEGER*2     bufsize,x,y
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxFilePrint
     +[PASCAL,ALIAS: 'PCXFILEPRINT']
     +(filename [REFERENCE],x,y)
      CHARACTER     filename
      INTEGER*2     x,y
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxLibPrint
     +[PASCAL,ALIAS: 'PCXLIBPRINT']
     +(libname [REFERENCE],filename [REFERENCE],x,y)
      CHARACTER     libname,filename
      INTEGER*2     x,y
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxEMInstalled
     +[PASCAL,ALIAS: 'PCXEMINSTALLED']
      END

      INTERFACE TO INTEGER*4 FUNCTION pcxVirtualSize
     +[PASCAL,ALIAS: 'PCXVIRTUALSIZE']
     +(disptype,width,depth)
      INTEGER*2     disptype,width,depth
      END

      INTERFACE TO INTEGER*4 FUNCTION pcxVirtualFree
     +[PASCAL,ALIAS: 'PCXVIRTUALFREE']
     +(vtype)
      INTEGER*2     vtype
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxCreateVirtual
     +[PASCAL,ALIAS: 'PCXCREATEVIRTUAL']
     +(vtype,vptr [REFERENCE],disptype,width,depth)
      INTEGER*2     vtype
      INTEGER*4     vptr
      INTEGER*2     disptype,width,depth
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxDestroyVirtual
     +[PASCAL,ALIAS: 'PCXDESTROYVIRTUAL']
     +(vptr)
      INTEGER*4     vptr
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxBufferVirtual
     +[PASCAL,ALIAS: 'PCXBUFFERVIRTUAL']
     +(buffer [REFERENCE],bufsize,vptr)
      CHARACTER     buffer
      INTEGER*2     bufsize
      INTEGER*4     vptr
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxFileVirtual
     +[PASCAL,ALIAS: 'PCXFILEVIRTUAL']
     +(filename [REFERENCE],vptr)
      CHARACTER     filename
      INTEGER*4     vptr
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxLibVirtual
     +[PASCAL,ALIAS: 'PCXLIBVIRTUAL']
     +(libname [REFERENCE],filename [REFERENCE],vptr)
      CHARACTER     libname,filename
      INTEGER*4     vptr
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxSetHerc
     +[PASCAL,ALIAS: 'PCXSETHERC']
     +(hercflag)
      INTEGER*2     hercflag
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxModeCheck
     +[PASCAL,ALIAS: 'PCXMODECHECK']
     +(modeflag)
      INTEGER*2     modeflag
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxVirtualDisplay
     +[PASCAL,ALIAS: 'PCXVIRTUALDISPLAY']
     +(vptr,vx,vy,x1,y1,x2,y2,page)
      INTEGER*4     vptr
      INTEGER*2     vx,vy,x1,y1,x2,y2,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxVirtualScroll
     +[PASCAL,ALIAS: 'PCXVIRTUALSCROLL']
     +(vptr,width,depth,x1,y1,x2,y2,page)
      INTEGER*4     vptr
      INTEGER*2     width,depth,x1,y1,x2,y2,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxLibSearch
     +[PASCAL,ALIAS: 'PCXLIBSEARCH']
     +(libname [REFERENCE],filemask [REFERENCE],libdir,sflag)
      CHARACTER     libname,filemask
      INTEGER*1     libdir
      INTEGER*2     sflag
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxVirtualPrint
     +[PASCAL,ALIAS: 'PCXVIRTUALPRINT']
     +(vptr,x,y)
      INTEGER*4     vptr
      INTEGER*2     x,y
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxDisplayPrint
     +[PASCAL,ALIAS: 'PCXDISPLAYPRINT']
     +(x,y)
      INTEGER*2     x,y
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxPutImage
     +[PASCAL,ALIAS: 'PCXPUTIMAGE']
     +(vptr,op,x,y,page)
      INTEGER*4     vptr
      INTEGER*2     op,x,y,page
      END

      INTERFACE TO INTEGER*2 FUNCTION pcxGetImage
     +[PASCAL,ALIAS: 'PCXGETIMAGE']
     +(vptr,x1,y1,x2,y2,page)
      INTEGER*4     vptr
      INTEGER*2     x1,y1,x2,y2,page
      END


