* pcxLib.FOR                                                                *
* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.  *

*****************************************************************************
*                                                                           *
* Parameter declarations for the PCX Programmer's Toolkit, MS Fortran 4.1.  *
*                                                                           *
*                                                                           *
*                                                                           *
* Microsoft Fortran 4.1                   Programmer: Chris Howard 12/09/88 *
*                                                                           *
*****************************************************************************

$NOTRUNCATE

* Functions
      INTEGER*2 pcxFileBuffer
      INTEGER*2 pcxBufferFile
      INTEGER*2 pcxSetDisplay
      INTEGER*2 pcxGetDisplay
      INTEGER*2 pcxSetMode
      INTEGER*2 pcxSetBuffer
      INTEGER*2 pcxBufferDisplay
      INTEGER*2 pcxDisplayBuffer
      INTEGER*2 pcxLibBuffer
      INTEGER*2 pcxFileDisplay
      INTEGER*2 pcxDisplayFile
      INTEGER*2 pcxLibDisplay
      INTEGER*2 pcxSetPage
      INTEGER*2 pcxGetPage
      INTEGER*2 pcxVerifyBuffer
      INTEGER*2 pcxGetBufferHeader
      INTEGER*2 pcxSetBufferHeader
      INTEGER*2 pcxGetBufferType
      INTEGER*2 pcxVerifyFile
      INTEGER*2 pcxGetFileHeader
      INTEGER*2 pcxSetFileHeader
      INTEGER*2 pcxGetFileType
      INTEGER*2 pcxGetLibHeader
      INTEGER*2 pcxGetLibType
      INTEGER*2 pcxDecodePalette
      INTEGER*2 pcxEncodePalette
      INTEGER*2 pcxSetDIsplayPalette
      INTEGER*2 pcxGetDisplayPalette
      INTEGER*2 pcxSetBufferPalette
      INTEGER*2 pcxGetBufferPalette
      INTEGER*2 pcxSetFilePalette
      INTEGER*2 pcxGetFilePalette
      INTEGER*2 pcxGetLibPalette
      INTEGER*2 pcxBeginPaletteGrab
      INTEGER*2 pcxEndPaletteGrab
      INTEGER*2 pcxGetVersion
      INTEGER*2 cpxTextBuffer
      INTEGER*2 pcxBufferText
      INTEGER*2 pcxVideoInfo
      INTEGER*2 pcxQueryChipset
      INTEGER*2 pcxGetDisplayInfo
      INTEGER*2 pcxSetPrinter
      INTEGER*2 pcxBufferPrint
      INTEGER*2 pcxFilePrint
      INTEGER*2 pcxLibPrint
      INTEGER*2 pcxEMInstalled
      INTEGER*4 pcxVirtualSize
      INTEGER*4 pcxVirtualFree
      INTEGER*2 pcxCreateVirtual
      INTEGER*2 pcxDestroyVirtual
      INTEGER*2 pcxBufferVirtual
      INTEGER*2 pcxFileVirtual
      INTEGER*2 pcxLibVirtual
      INTEGER*2 pcxSetHerc
      INTEGER*2 pcxModeCheck
      INTEGER*2 pcxVirtualDisplay
      INTEGER*2 pcxVirtualScroll
      INTEGER*2 pcxLibSearch
      INTEGER*2 pcxVirtualPrint
      INTEGER*2 pcxDisplayPrint
      INTEGER*2 pcxPutImage
      INTEGER*2 pcxGetImage

* PCX Display modes
      INTEGER*2  pcxTEXT,pcxGRAPHICS
      PARAMETER (pcxTEXT     = 0)
      PARAMETER (pcxGRAPHICS = 1)

* PCX Display types
      INTEGER*2  pcxMINDISP,pcxCGA_4,pcxCGA_6,pcxEGA_D,pcxEGA_E
      INTEGER*2  pcxEGA_F,pcxEGA_10,pcxVGA_11,pcxVGA_12,pcxVGA_13
      INTEGER*2  pcxHERC
      PARAMETER (pcxMINDISP  = 0)
*     CGA Mode  4H (320x200x4)
      PARAMETER (pcxCGA_4    = 0)
*     CGA Mode  6H (640x200x2)
      PARAMETER (pcxCGA_6    = 1)
*     EGA Mode  DH (320x200x16)
      PARAMETER (pcxEGA_D    = 2)
*     EGA Mode  EH (640x200x16)
      PARAMETER (pcxEGA_E    = 3)
*     EGA Mode  FH (640x350x2)
      PARAMETER (pcxEGA_F    = 4)
*     EGA Mode 10H (640x350x16)
      PARAMETER (pcxEGA_10   = 5)
*     VGA Mode 11H (640x480x2)
      PARAMETER (pcxVGA_11   = 6)
*     VGA Mode 12H (640x480x16)
      PARAMETER (pcxVGA_12   = 7)
*     VGA Mode 13H (320x200x256)
      PARAMETER (pcxVGA_13   = 8)
*     Hercules     (720x348x2)
      PARAMETER (pcxHERC     = 9)

* New extended VGA modes
      INTEGER*2  pcxXGA_29,pcxXGA_2D,pcxXGA_2E,pcxXGA_30,pcxXGA_58
      INTEGER*2  pcxXGA_59,pcxXGA_5E,pcxXGA_5F,pcxXGA_62,pcxXGA_66
      INTEGER*2  pcxXGA_67,pcxXGA_69,pcxMAXDISP
*     Tseng Mode 29H (800x600x16)
      PARAMETER (pcxXGA_29   = 10)
*     Tseng Mode 2DH (640x350x256)
      PARAMETER (pcxXGA_2D   = 11)
*     Tseng Mode 2EH (640x480x256)
      PARAMETER (pcxXGA_2E   = 12)
*     Tseng Mode 30H (800x600x256)
      PARAMETER (pcxXGA_30   = 13)
*     Paradise Mode 58H (800x600x16)
      PARAMETER (pcxXGA_58   = 14)
*     Paradise Mode 59H (800x600x2)
      PARAMETER (pcxXGA_59   = 15)
*     Paradise Mode 5FH (640x400x256)
      PARAMETER (pcxXGA_5E   = 16)
*     Paradise Mode 5FH (640x480x256)
      PARAMETER (pcxXGA_5F   = 17)
*     Video 7 Mode 62H (800x600x16)
      PARAMETER (pcxXGA_62   = 18)
*     Video 7 Mode 66H (640x400x256)
      PARAMETER (pcxXGA_66   = 19)
*     Video 7 Mode 67H (640x480x256)
      PARAMETER (pcxXGA_67   = 20)
*     Video 7 Mode 69H (800x600x256)
      PARAMETER (pcxXGA_69   = 21)
      PARAMETER (pcxMAXDISP  = 20)

* Printer Ports
      INTEGER*2  pcxLPT1,pcxLPT2,pcxLPT3
*     Printer Port 1
      PARAMETER (pcxLPT1     = 0)
*     Printer Port 2
      PARAMETER (pcxLPT2     = 1)
*     Printer Port 3
      PARAMETER (pcxLPT3     = 2)

* Printer Types
      INTEGER*2  pcxMINPRINT,pcxLASER,pcxDOTMAT,pcxMAXPRINT
*     Minimum printer type
      PARAMETER (pcxMINPRINT = 0)
*     HP LaserJet
      PARAMETER (pcxLASER    = 0)
*     Dot Matrix
      PARAMETER (pcxDOTMAT   = 1)
*     Maximum printer type
      PARAMETER (pcxMAXPRINT = 1)

* Printer Modes
      INTEGER*2  pcxDRAFT,pcxQUALITY
*     Draft Mode
      PARAMETER (pcxDRAFT    = 0)
*     Quality
      PARAMETER (pcxQUALITY  = 0)

* Printer Scales
      INTEGER*2  pcxSCALE100,pcxSCALE75,pcxSCALE50,pcxSCALE25
      INTEGER*2  pcxSCALE200
*     100%
      PARAMETER (pcxSCALE100 = 0)
*     75%
      PARAMETER (pcxSCALE75  = 1)
*     50%
      PARAMETER (pcxSCALE50  = 2)
*     25%
      PARAMETER (pcxSCALE25  = 3)
*     200%
      PARAMETER (pcxSCALE200 = 4)

* Printer Flags
      INTEGER*2  pcxNORESET,pcxRESET,pcxNOEJECT,pcxEJECT
*     No reset before printing
      PARAMETER (pcxNORESET  = 0)
*     Reset before printing
      PARAMETER (pcxRESET    = 1)
*     No eject after printing
      PARAMETER (pcxNOEJECT  = 0)
*     Eject page after printing
      PARAMETER (pcxEJECT    = 1)

* Searches
      INTEGER*2  pcxFIRST,pcxNEXT
*     Find first matching entry
      PARAMETER (pcxFIRST    = 0)
*     Find next matching entry
      PARAMETER (pcxNEXT     = 0)

* Logical Operations
      INTEGER*2  pcxSET,pcxAND,pcxOR,pcxXOR
*     SET pixel value directly
      PARAMETER (pcxSET      = 0)
*     AND pixel value with data
      PARAMETER (pcxAND      = 1)
*     OR  pixel value with data
      PARAMETER (pcxOR       = 2)
*     XOR pixel value with data
      PARAMETER (pcxXOR      = 3)

* Virtual Screens
      INTEGER*2  pcxEMM,pcxCMM
*     Expanded Memory virtual
      PARAMETER (pcxEMM      = 0)
*     Conventional Memory virtual
      PARAMETER (pcxCMM      = 1)

* Miscellaneous
      INTEGER*2  pcxTRUE,pcxFALSE,pcxSYNC
*     True value
      PARAMETER (pcxTRUE     = 1)
*     False value
      PARAMETER (pcxFALSE    = 0)
*     PCX library synch value
      PARAMETER (pcxSYNC     = 1)

* Video Info Constants
      INTEGER*2  viNONE,viMDA,viCGA,viEGA,viMCGA,viVGA
      INTEGER*2  viHGC,viHGCPlus,viHGCColor
*     No adapter/display
      PARAMETER (viNONE      = 0)
*     Monochrome Display Adapter
      PARAMETER (viMDA       = 1)
*     Color Graphicx Adapter
      PARAMETER (viCGA       = 2)
*     Enhanced Graphics Adapter
      PARAMETER (viEGA       = 3)
*     Multi-Color Graphics Array
      PARAMETER (viMCGA      = 4)
*     Video Graphics Array
      PARAMETER (viVGA       = 5)
*     Hercules Monochrome
      PARAMETER (viHGC       = #80)
*     Hercules Plus
      PARAMETER (viHGCPlus   = #81)
*     Hercules InColor
      PARAMETER (viHGCColor  = #82)

      INTEGER*2  viMDAdisp,viCGAdisp,viEGAdisp,viVGAmono,viVGAcolor
*     Monochrome Display
      PARAMETER (viMDAdisp   = 1)
*     CGA Display
      PARAMETER (viCGAdisp   = 2)
*     EGA Display
      PARAMETER (viEGAdisp   = 3)
*     VGA Monochrome Display
      PARAMETER (viVGAmono   = 4)
*     VGA Color Display
      PARAMETER (viVGAcolor  = 5)

* Chip sets
      INTEGER*2  chipUNKNOWN,chipTSENG,chipPARA,chipV7
*     Unknown chip set
      PARAMETER (chipUNKNOWN = 0)
*     Tseng Labs
      PARAMETER (chipTSENG   = 1)
*     Paradise
      PARAMETER (chipPARA    = 2)
*     Video 7
      PARAMETER (chipV7      = 3)

* Hercules Configuration
      INTEGER*2  pcxHERCdiag,pcxHERChalf,pcxHERCfull
*     Hercules Diagnostic
      PARAMETER (pcxHERCdiag = 0)
*     Hercules Half
      PARAMETER (pcxHERChalf = 1)
*     Hercules Full
      PARAMETER (pcxHERCfull = 3)

* Error Codes
      INTEGER*2  pcxSUCCESS,pcxERR_OPEN,pcxERR_BUFSMALL,pcxERR_READ
      INTEGER*2  pcxERR_WRITE,pcxERR_NOTPCX,pcxERR_BADDISP
      INTEGER*2  pcxERR_BADMODE,pcxERR_BADPAGE,pcxERR_BADPAL
      INTEGER*2  pcxERR_NOPAL,pcxERR_NOPALGRAB,pcxERR_NOTPCXLIB
      INTEGER*2  pcxERR_NOSYNC,pcxERR_NOTINLIB,pcxERR_CLIPPARM
      INTEGER*2  pcxERR_NOTIMPL,pcxERR_GENERAL
*     Successful
      PARAMETER (pcxSUCCESS       =  0)
*     Error opening file
      PARAMETER (pcxERR_OPEN      = -1)
*     Buffer is too small
      PARAMETER (pcxERR_BUFSMALL  = -2)
*     Error in reading from file
      PARAMETER (pcxERR_READ      = -3)
*     Error in writing to file
      PARAMETER (pcxERR_WRITE     = -4)
*     Not a valid pcx buffer/file
      PARAMETER (pcxERR_NOTPCX    = -5)
*     Display not defined/invalid
      PARAMETER (pcxERR_BADDISP   = -6)
*     Bad display mode
      PARAMETER (pcxERR_BADMODE   = -7)
*     Bad page
      PARAMETER (pcxERR_BADPAGE   = -8)
*     Bad palette
      PARAMETER (pcxERR_BADPAL    = -9)
*     No palette is available
      PARAMETER (pcxERR_NOPAL     = -10)
*     Palette is not grabbed
      PARAMETER (pcxERR_NOPALGRAB = -11)
*     Not a PCX library
      PARAMETER (pcxERR_NOTPCXLIB = -12)
*     Lost image synch in library
      PARAMETER (pcxERR_NOSYNC    = -13)
*     Image not found in library
      PARAMETER (pcxERR_NOTINLIB  = -14)
*     Bad number of Clipper parms
      PARAMETER (pcxERR_CLIPPARM  = -15)
*     Not implemented yet
      PARAMETER (pcxERR_NOTIMPL   = -900)
*     General error
      PARAMETER (pcxERR_GENERAL   = -999)

* New errors for version 3.5
      INTEGER*2  pcxERR_BADPRINT,pcxERR_BADPORT,pcxERR_PRINTER
      INTEGER*2  pcxERR_NOTBW,pcxERR_ESCAPE,pcxERR_NOEMM,pcxERR_EMMFAIL
      INTEGER*2  pcxERR_EMMNOMEM,pcxERR_BADMEMTYPE,pcxERR_CMMFAIL
      INTEGER*2  pcxERR_CMMNOMEM
*     Bad printer type
      PARAMETER (pcxERR_BADPRINT  = -16)
*     Bad printer port
      PARAMETER (pcxERR_BADPORT   = -17)
*     Printer error (timeout, i/o, paper)
      PARAMETER (pcxERR_PRINTER   = -18)
*     Not a Black/White image
      PARAMETER (pcxERR_NOTBW     = -19)
*     Escape key was pressed
      PARAMETER (pcxERR_ESCAPE    = -20)
*     No Emm driever was found
      PARAMETER (pcxERR_NOEMM     = -21)
*     General EMM driver failure
      PARAMETER (pcxERR_EMMFAIL   = -22)
*     No EMM memory available
      PARAMETER (pcxERR_EMMNOMEM  = -23)
*     Bad virtual memory type
      PARAMETER (pcxERR_BADMEMTYPE= -24)
*     General CMM alloc/free error
      PARAMETER (pcxERR_CMMFAIL   = -25)
*     No CMM memory available
      PARAMETER (pcxERR_CMMNOMEM  = -26)

* PCX Header
      INTEGER*1     manuf,hard,encod,bitpx
      INTEGER*2     x1,y1,x2,y2,hres,vres
      INTEGER*1     clrma(48)
      INTEGER*1     vmode,nplanes
      INTEGER*2     bplin,palinfo,shres,svres
      INTEGER*1     xtra(54)
      COMMON /PCXHEADER/
     +  manuf,hard,encod,bitpx,x1,y1,x2,y2,hres,vres,clrma,vmode,
     +  nplanes,bplin,palinfo,shres,svres,xtra

* Image Library Header
      INTEGER*1     id(10),copyright(50),version,label(40)
      INTEGER*1     lextra(20)
      COMMON /PCXLIBHEADER/
     +  id,copyright,version,label,lextra

* Image Library Image Header
      INTEGER*1     synch
      CHARACTER*13  filename
      INTEGER*4     filesize
      INTEGER*2     date,time,pack
      CHARACTER*40  note
      INTEGER*1     dextra(20)
      COMMON /PCXLIBDIR/
     +  synch,filename,filesize,date,time,pack,note,dextra

* PCX Toolkit Display Type Information
      INTEGER*1     type
      CHARACTER*21  descrip
      INTEGER*1     mode
      INTEGER*1     dbitpx
      INTEGER*2     dhres,dvres
      INTEGER*1     dplanes,dpages
      INTEGER*2     begseg,pagesize,paltype
      INTEGER*4     dispfunc,bufffunc,virtfunc,putfunc,getfunc
      COMMON /PCXDINFO/
     +  type,descrip,mode,dbitpx,dhres,dvres,dplanes,dpages,begseg,
     +  pagesize,paltype,dispfunc,bufffunc,virtfunc,putfunc,getfunc

* Video Information
      INTEGER*1     adapter1,display1,adapter2,display2
      COMMON /PCXVINFO/
     +  adapter1,display1,adapter2,display2


