{* Simple.PAS                                                               *}
{* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. *}

{****************************************************************************

  This program is the simplest example of toolkit usage. It is an example
  Pascal routine for the PCX Programmer's Toolkit.

  NOTE: REQUIRES A CGA (or compatible) ADAPTER AND DISPLAY!


  Borland Turbo Pascal 4.0/5.0            Programmer: Chris Howard  4/15/89

*****************************************************************************}

Program Simple;

{ Include the PCX Toolkit Unit, and any other units needed }
uses pcx_tp,crt;

{ Globals }
const
  pcxtype        = pcxCGA_4;
  pcximage       = 'Simple.PCX';

var
  retcode        : integer;
  dispret        : integer;
  key            : char;

{**********}

begin

  { Display program header }
  writeln;
  writeln(' Simple Example Pascal PCX Program ');
  writeln;

  { Get a key, to begin }
  writeln('Press a key to run . . .');
  key := ReadKey;

  { Set the display type and mode we will be using }
  retcode := pcxSetDisplay(pcxtype);

  { Now enter graphics mode }
  retcode := pcxSetMode(pcxGRAPHICS);

  { Now display the image file }
  if (retcode = pcxSUCCESS) then begin
    dispret := pcxFileDisplay(pcximage,0,0,0);

    { Wait for a key }
    key := ReadKey;

    { Return to text mode }
    retcode := pcxSetMode(pcxTEXT);
  end; {of if}

  { Check if everything went OK }
  if (dispret <> pcxSUCCESS) then begin
    writeln;
    writeln('An error occurred: [',dispret,']');
    writeln;
    writeln('You may not have a CGA, or the image SIMPLE.PCX may not');
    writeln('be in the current directory ...');
    writeln;
  end; {of if}

end. { end of main }

