{* Structs.PAS                                                              *}
{* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. *}

{****************************************************************************

  This program demonstrates the usage of various toolkit structures. It is 
  an example Pascal routine for the PCX Programmer's Toolkit.


  Borland Turbo Pascal 4.0/5.0            Programmer: Chris Howard  4/15/89

*****************************************************************************}

Program Structs;

{ Include the PCX Toolkit Unit, and any other units needed }
uses pcx_tp,crt;

{ Globals }
const
  pcximage       = 'pcxTest.PCX';

  viadapt        : array[0..5] of string[10]
                 = ('[None]','MDA','CGA','EGA','MCGA','VGA');

  viherc         : array[0..2] of string[10]
                 = ('HGC','HGC+','InColor');

  vidisp         : array[0..5] of string[25]
                 = ('[None]','MDA Monochrome Display','CGA Color Display',
                    'EGA Color Display','VGA Monochrome Display',
                    'VGA Color Display');

  chip           : array[0..3] of string[10]
                 = ('[Unknown]','Tseng Labs','Paradise','Video7');

var
  header         : PCXHEADER;
  vi             : array [1..2] of PCXVINFO;
  di             : PCXDINFO;

  pcxtype        : integer;
  i,retcode      : integer;
  chipset        : integer;
  key            : char;

{**********}

begin

  { Display program header }
  writeln;
  writeln('͸');
  writeln(' Structs: Example Structures Pascal Program PCX Programmer''s Toolkit 3.50 ');
  writeln(' Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. ');
  writeln(';');
  writeln;

  { Get a key, to begin }
  writeln('Press a key to run . . .');
  key := ReadKey;

  { Look at the current hardware, to find a B/W mode }
  retcode := pcxVideoInfo(@vi);

  { Display what we found }
  writeln('Video Information:');
  writeln;
  for i := 1 to 2 do begin
    { Is there an adapter here? }
    if (vi[i].adapter <> viNONE) then begin
      { Display, and use the other array if Hercules }
      if (vi[i].adapter >= viHGC) then
        writeln('  ',viherc[vi[i].adapter-viHGC],' with a ',vidisp[vi[i].display])
      else
        writeln('  ',viadapt[vi[i].adapter],' with a ',vidisp[vi[i].display])
    end; {of if}
    { If this is a VGA, try to find a chipset }
    if (vi[i].adapter = viVGA) then begin
      chipset := pcxQueryChipset;
      writeln('   chipset: ',chip[chipset]);
    end;
  end; {of for}

  { Wait for a key }
  writeln;
  writeln('Press a key to continue . . .');
  key := ReadKey;

  { Get an image header }
  retcode := pcxGetFileHeader(pcximage,@header);

  { If we read it successfully, display some information }
  if (retcode = pcxSUCCESS) then begin

    { Access the header directly }
    with header do begin

      writeln;
      writeln('Header structure for ',pcximage,': ');
      writeln;
      writeln('    manuf: ',  manuf);
      writeln('     hard: ',   hard);
      writeln('    encod: ',  encod);
      writeln('    bitpx: ',  bitpx);
      writeln('       x1: ',     x1);
      writeln('       y1: ',     y1);
      writeln('       x2: ',     x2);
      writeln('       y2: ',     y2);
      writeln('     hres: ',   hres);
      writeln('     vres: ',   vres);
      writeln('    vmode: ',  vmode);
      writeln('  nplanes: ',nplanes);
      writeln('    bplin: ',  bplin);
      writeln;

    end; {of with}

  end; {of if}

  { Wait for a key }
  writeln('Press a key to continue . . .');
  key := ReadKey;

  { Now get information on a PCX type }
  retcode := pcxGetDisplayInfo(pcxEGA_10,@di);

  { Display some information }
  writeln;
  writeln('Information on the ''pcxEGA_10'' display type:');
  writeln;
  writeln('     type: ',di.dtype);
  writeln('  descrip: [',di.descrip,']');
  writeln('     mode: ',di.mode);
  writeln('    bitpx: ',di.bitpx);
  writeln('     hres: ',di.hres);
  writeln('     vres: ',di.vres);
  writeln('   planes: ',di.planes);
  writeln('    pages: ',di.pages);
  writeln('   begseg: ',di.begseg);
  writeln(' pagesize: ',di.pagesize);

  writeln;

  { Wait for a key }
  writeln('Press a key to end . . .');
  key := ReadKey;

end. { end of main }

